package dev.shadowsoffire.apotheosis.adventure.client;

import net.minecraft.client.renderer.RenderType;
import net.minecraft.client.renderer.MultiBufferSource;
import java.util.function.Function;
import com.mojang.blaze3d.vertex.VertexConsumer;

public class GhostVertexBuilder implements VertexConsumer
{
    private final VertexConsumer wrapped;
    private final int alpha;
    
    public GhostVertexBuilder(final VertexConsumer wrapped, final int alpha) {
        this.wrapped = wrapped;
        this.alpha = alpha;
    }
    
    public VertexConsumer m_5483_(final double x, final double y, final double z) {
        return this.wrapped.m_5483_(x, y, z);
    }
    
    public VertexConsumer m_6122_(final int red, final int green, final int blue, final int alpha) {
        return this.wrapped.m_6122_(red, green, blue, alpha * this.alpha / 255);
    }
    
    public VertexConsumer m_7421_(final float u, final float v) {
        return this.wrapped.m_7421_(u, v);
    }
    
    public VertexConsumer m_7122_(final int u, final int v) {
        return this.wrapped.m_7122_(u, v);
    }
    
    public VertexConsumer m_7120_(final int u, final int v) {
        return this.wrapped.m_7120_(u, v);
    }
    
    public VertexConsumer m_5601_(final float x, final float y, final float z) {
        return this.wrapped.m_5601_(x, y, z);
    }
    
    public void m_5752_() {
        this.wrapped.m_5752_();
    }
    
    public void m_7404_(final int pRed, final int pGreen, final int pBlue, final int pAlpha) {
    }
    
    public void m_141991_() {
    }
    
    public static Function<MultiBufferSource, MultiBufferSource> makeGhostBuffer(final int alpha) {
        return (Function<MultiBufferSource, MultiBufferSource>)(mbs -> new GhostBufferSource(mbs, alpha));
    }
    
    public static class GhostBufferSource implements MultiBufferSource
    {
        private final MultiBufferSource wrapped;
        private final int alpha;
        
        public GhostBufferSource(final MultiBufferSource wrapped, final int alpha) {
            this.wrapped = wrapped;
            this.alpha = alpha;
        }
        
        public VertexConsumer m_6299_(final RenderType type) {
            return (VertexConsumer)new GhostVertexBuilder(this.wrapped.m_6299_(type), this.alpha);
        }
    }
}
